/* 
 * File:   software_SPI.h
 * Author: chengo_cc
 *
 * Created on 17 December 2015, 12:29 PM
 */

#ifndef SOFTWARE_SPI_H
//------------------------------------------------------------------------------
void SPI_init(void)
{
  SCK_dir = 0;
  SDI_dir = 1;
  SDO_dir = 0;
  CS_dir  = 0;
}
//--------------------------TX: transmit data-----------------------------------
void SPI_TX(unsigned short send)
{
  for(int Tx = 0 ; Tx < 8 ; Tx++ )
  {
    SCK = 0;
    SDO = ( (send << Tx) & 0x80 ) ? 1 : 0; //MSB first.
    SCK = 1;                  //Toggle SCK pin to create a sqaure wave.
  }
}
//--------------------------RX: recieve data------------------------------------
char SPI_RX(void)
{
  char data = 0;

  for(int Rx = 0 ; Rx < 8 ; Rx++ )
  {
    SCK = 0;
    data += (SDI << (7-Rx));  //MSB first.
    SCK = 1;
  }

  return data;
}
//------------------------------------------------------------------------------
#define	SOFTWARE_SPI_H

#ifdef	__cplusplus
extern "C" {
#endif




#ifdef	__cplusplus
}
#endif

#endif	/* SOFTWARE_SPI_H */

